// *****************************************************************************
// Copyright (c)  2016, 2017, 2018, 2019, 2020, 2021, 2022, 2023, 2024 joshua.tee@gmail.com. All rights reserved.
//
// Refer to the COPYING file of the official project for license.
// *****************************************************************************

final class UtilityModelNcepInterface {
    
    static let models = [
        "FIREWX",
        "GEFS-MEAN-SPRD",
        "GEFS-SPAG",
        "GFS",
        "HREF",
        "HRRR",
        "HRW-ARW",
        "HRW-ARW2",
        "HRW-FV3",
        "NAEFS",
        "NAM",
        "NAM-HIRES",
        "NBM",
        "POLAR",
        "RAP",
        "SREF",
        "STOFS",
        "GEFS-WAVE",
        "GFS-WAVE"
    ]
    
    static let sectorsGfs = [
        "CONUS",
        "NAMER",
        "SAMER",
        "AFRICA",
        "NORTH-PAC",
        "EAST-PAC",
        "WEST-ATL",
        "ATLANTIC",
        "POLAR",
        "ALASKA",
        "EUROPE",
        "ASIA",
        "SOUTH-PAC",
        "ARTIC",
        "INDIA",
        "US-SAMOA",
        "PAC-REGION"
    ]
    
    static let sectorsNam = [
        "CONUS",
        "NAMER",
        "NORTH-PAC",
        "EAST-PAC",
        "WN-ATL"
    ]
    
    static let sectorsNam4km = [
        "CONUS",
        "ALASKA",
        "Hawaii",
        "US-NW",
        "US-SW",
        "US-NC",
        "US-SC",
        "US-NE",
        "US-SE"
    ]
    
    static let sectorsRap = [
        "CONUS",
        "NAMER"
    ]
    
    static let sectorsHrrr = [
        "CONUS",
        "US-NW",
        "US-SW",
        "US-NC",
        "US-SC",
        "US-NE",
        "US-SE",
        "ALASKA"
    ]
    
    static let sectorsSref = [
        "NAMER",
        "ALASKA"
    ]
    
    static let sectorsNaefs = [
        "CONUS",
        "ALASKA",
        "NAMER",
        "SAMER",
        "AFRICA",
        "NORTH-PAC",
        "EAST-PAC",
        "WN-ATL",
        "ATLANTIC",
        "EUROPE",
        "ASIA",
        "SOUTH-PAC",
        "INDIA",
        "POLAR",
        "ARCTIC"
    ]
    
    static let sectorsPolar = [
        "POLAR"
    ]
    
    static let sectorsHrwNmm = [
        "CONUS",
        "HAWAII",
        "GUAM",
        "ALASKA",
        "PR",
        "US-NW",
        "US-SW",
        "US-NC",
        "US-SC",
        "US-NE",
        "US-SE"
    ]
    
    static let sectorsGefsSpag = [
        "NAMER",
        "SAMER",
        "AFRICA",
        "NORTH-PAC",
        "EAST-PAC",
        "WN-ATL",
        "ATLANTIC",
        "EUROPE",
        "ASIA",
        "SOUTH-PAC",
        "INDIA"
    ]
    
    static let sectorsGefsMnsprd = [
        "CONUS",
        "ALASKA",
        "NAMER",
        "SAMER",
        "AFRICA",
        "NORTH-PAC",
        "EAST-PAC",
        "WN-ATL",
        "ATLANTIC",
        "EUROPE",
        "ASIA",
        "SOUTH-PAC",
        "INDIA",
        "POLAR",
        "ARCTIC"
    ]
    
    static let sectorsGefsWave = [
        "AFRICA",
        "ALASKA",
        "ARCTIC",
        "ATL-PAC",
        "ATLANTIC",
        "EAST-GOA",
        "EAST-PAC",
        "EUROPE",
        "GOM",
        "GUAM",
        "HAWAII",
        "INDIA",
        "MID-ATL",
        "NE-COAST",
        "NORTH-CAL",
        "NORTH-PAC",
        "PAC-REGION",
        "POLAR",
        "PR",
        "SE-COAST",
        "SOUTH-CAL",
        "US-SAMOA",
        "WA-OR",
        "WEST-ATL",
        "WEST-GOA"
    ]
    
    static let sectorsGfsWave = [
        "AFRICA",
        "ALASKA",
        "ARCTIC",
        "ATL-PAC",
        "ATLANTIC",
        "EAST-GOA",
        "EAST-PAC",
        "EUROPE",
        "GOM",
        "GUAM",
        "HAWAII",
        "INDIA",
        "MID-ATL",
        "NE-COAST",
        "NORTH-CAL",
        "NORTH-PAC",
        "PAC-REGION",
        "POLAR",
        "PR",
        "SE-COAST",
        "SOUTH-CAL",
        "US-SAMOA",
        "WA-OR",
        "WEST-ATL",
        "WEST-GOA"
    ]
    
    static let sectorsStofs = [
        "EAST-GOA",
        "EAST-GOM",
        "HAWAII",
        "MID-ATL",
        "NE-COAST",
        "NORTH-CAL",
        "SE-COAST",
        "SOUTH-CAL",
        "WA-OR",
        "WEST-GOA",
        "WEST-GOM"
    ]
    
    static let sectorsFirewx = [
        "CONUS-AK"
    ]
    
    static let sectorsHrwArw2 = [
        "CONUS",
        "HAWAII",
        "ALASKA",
        "PR",
        "US-NW",
        "US-SW",
        "US-NC",
        "US-SC",
        "US-NE",
        "US-SE"
    ]
    
    static let sectorsHref = [
        "CONUS",
        "US-NW",
        "US-SW",
        "US-NC",
        "US-SC",
        "US-NE",
        "US-SE"
    ]
    
    static let sectorsNbm = [
        "ALASKA",
        "CONUS",
        "HAWAII",
        "NAMER",
        "PR"
    ]
    
    static let modelGfsParams = [
        "1000_500_thick",
        "1000_850_thick",
        "850_700_thick",
        "10m_wnd_precip",
        "10m_wnd_2m_temp",
        "850_temp_mslp_precip",
        "200_wnd_ht",
        "250_wnd_ht",
        "300_wnd_ht",
        "500_rh_ht",
        "500_wnd_ht",
        "500_vort_ht",
        "700_rh_ht",
        "850_pw_ht",
        "850_rh_ht",
        "850_temp_ht",
        "850vor_500ht_200wd",
        "850_vort_ht",
        "925_temp_ht",
        "precip_p01",
        "precip_p03",
        "precip_p06",
        "precip_p12",
        "precip_p24",
        "precip_p36",
        "precip_p48",
        "precip_p60",
        "precip_ptot",
        "precip_rate_type",
        "dom_precip_type",
        "sim_radar_comp",
        "snodpth_chng"
    ]
    
    static let modelGfsLabels = [
        "MSLP, 1000-500mb thickness, 0x hr PCPN (in.)",
        "MSLP, 1000-850mb thickness, 0x hr PCPN (in.)",
        "MSLP, 850-700mb thickness, 0x hr PCPN (in.)",
        "MSLP, 10 Meter Wind & Precip",
        "MSLP, 10 Meter Wind & 2 Meter Temp",
        "MSLP, 850mb temperature, 6 hourly total precipitation",
        "200mb Wind and Height",
        "250mb Wind and Height",
        "300mb Wind and Height",
        "500mb Relative Humidity and Height",
        "500mb Wind and Height",
        "500mb Vorticity, Wind, and Height",
        "700mb Relative Humidity, Height and Omega",
        "850mb Height, Precipitable Water and Wind",
        "850mb Relative Humidity and Height",
        "850mb Temperature, Wind and Height",
        "850mb Vorticity, 500mb Height, 200mb Wind",
        "850mb Vorticity, Wind and Height",
        "925mb Temperature, Wind and Height",
        "Total Precipitation every 1 hour",
        "Total Precipitation every 3 hours",
        "Total Precipitation every 6 hours",
        "Total Precipitation every 12 hours",
        "Total Precipitation every 24 hours",
        "Total Precipitation every 36 hours",
        "Total Precipitation every 48 hours",
        "Total Precipitation every 60 hours",
        "Total Accumulated Precipitation of Period",
        "Precip Rate(IN/HR), 1000-500MB Thickness",
        "Dominant Precipitation Type",
        "Composite Radar Reflectivity",
        "Snow Depth Change for previous 001 hours"
    ]
    
    static let modelNamParams = [
        "precip_p03",
        "precip_p06",
        "precip_p12",
        "precip_p24",
        "precip_p36",
        "precip_p48",
        "precip_p60",
        "precip_ptot",
        "precip_rate_type",
        "snodpth_chng",
        "1000_500_thick",
        "1000_850_thick",
        "10m_wnd_2m_temp",
        "10m_wnd_precip",
        "850_700_thick",
        "850_temp_mslp_precip",
        "sim_radar_1km",
        "200_wnd_ht",
        "250_wnd_ht",
        "300_wnd_ht",
        "500_rh_ht",
        "500_wnd_ht",
        "500_vort_ht",
        "700_rh_ht",
        "850_pw_ht",
        "850_rh_ht",
        "850_temp_ht",
        "850_vort_ht",
        "850vor_500ht_200wd",
        "925_temp_ht"
    ]
    
    static let modelNamLabels = [
        "Total Precipitation every 3 hours",
        "Total Precipitation every 6 hours",
        "Total Precipitation every 12 hours",
        "Total Precipitation every 24 hours",
        "Total Precipitation every 36 hours",
        "Total Precipitation every 48 hours",
        "Total Precipitation every 60 hours",
        "Total Accumulated Precipitation of Period",
        "Precip Rate(IN/HR), 1000-500MB Thickness",
        "Snow Depth Change for previous 001 hours",
        "MSLP, 1000-500mb thickness, 6 hourly total precipitation",
        "MSLP, 1000-850mb thickness, 6 hourly total precipitation",
        "MSLP, 10m wind, 2m temperature",
        "MSLP, 10m wind, 6 houly total precip, 2m temperature",
        "MSLP, 850-700mb thickness, 6 hourly total precipitation",
        "MSLP, 850mb temperature, 6 hourly total precipitation",
        "Simulated Radar Reflectivity",
        "200mb Wind and Height",
        "250mb Wind and Height",
        "300mb Wind and Height",
        "500mb Relative Humidity and Height",
        "500mb Wind and Height",
        "500mb Vorticity, Wind, and Height",
        "700mb Relative Humidity, Height and Omega",
        "850mb Height, Precipitable Water and Wind",
        "850mb Relative Humidity and Height",
        "850mb Temperature, Wind and Height",
        "850mb Vorticity, Wind and Height",
        "850mb Vorticity, 500mb Height, 200mb Wind",
        "925mb Temperature, Wind and Height"
    ]
    
    static let modelRapParams = [
        "precip_p01",
        "precip_ptot",
        "precip_rate",
        "snow_total",
        "1000_500_thick",
        "1000_850_thick",
        "850_700_thick",
        "cape_cin",
        "echo_top",
        "helicity",
        "vis",
        "sim_radar_1km",
        "sim_radar_comp",
        "2m_temp_10m_wnd",
        "2m_dewp_10m_wnd",
        "10m_wnd_sfc_gust",
        "200_wnd_ht",
        "250_wnd_ht",
        "300_wnd_ht",
        "500_vort_ht",
        "500_temp_ht",
        "700_rh_ht",
        "850_temp_ht",
        "925_temp_ht"
    ]
    
    static let modelRapLabels = [
        "Hourly Total Precipitation",
        "Total Accumulated Precipitation",
        "Precipitation Rate",
        "RAP 1-hr Snow Acc (in.)",
        "MSLP, 1000-500mb thickness, 0-1hr PCPN (in.)",
        "MSLP, 1000-850mb thickness, 0-1hr PCPN (in.)",
        "MSLP, 850-700mb thickness, 0-1hr PCPN (in.)",
        "CAPE/CIN (J/KG)",
        "Echo Top Height Image",
        "Helicity and 30m Wind",
        "Visibility",
        "Simulated Radar Reflectivity",
        "Composite Radar Reflectivity",
        "2 Meter Temp and 10 Meter Wind",
        "2 Meter Dew Point and 10 Meter Wind",
        "10 Meter Wind and Surface Gust",
        "200mb Wind and Height",
        "250mb Wind and Height",
        "300mb Wind and Height",
        "500mb Vorticity, Wind, and Height",
        "500mb Temperature, Wind and Height",
        "700mb Relative Humidity, Wind, Height and Omega",
        "850mb Temperature, Wind, and Height",
        "925mb Temperature, Wind and Height"
    ]
    
    static let modelHrrrParams = [
        "precip_p01",
        "precip_ptot",
        "precip_type",
        "precip_rate",
        "precip_rate_type",
        "snow_total",
        "1000_500_thick",
        "1000_850_thick",
        "850_700_thick",
        "850_temp_mslp_precip",
        "echo_top",
        "helicity_3km",
        "helicity_1km",
        "lightning",
        "sim_radar_1km",
        "sim_radar_comp",
        "sim_radar_max",
        "10m_wnd",
        "2m_temp_10m_wnd",
        "2m_dewp_10m_wnd",
        "10m_wnd_sfc_gust",
        "vis",
        "max_updraft_hlcy",
        "accu_max_updraft_hlcy",
        "10m_maxwnd",
        "sfc_cape_cin",
        "best_cape_cin",
        "250_wnd",
        "300_wnd",
        "500_vort_ht",
        "500_temp_ht",
        "700_rh_ht",
        "850_temp_ht",
        "925_temp_wnd",
        "ceiling"
    ]
    
    static let modelHrrrLabels = [
        "Hourly Total Precipitation",
        "15-hr Total Precipitation",
        "Precipitation Type",
        "Precipitation Rate",
        "Precip Rate(IN/HR), 1000-500MB Thickness",
        "1-hr Snow Acc (in.) ",
        "PMSL, 1000-500mb thickness, hourly precipitation",
        "PMSL, 1000-850mb thickness, hourly precipitation",
        "PMSL, 850-700mb thickness, hourly precipitation",
        "MSLP, 850mb temperature, 1hourly precipitation",
        "Echo Tops",
        "0-3km Helicity and Storm Motion",
        "0-1km Helicity and Storm Motion",
        "Lightning Flash Rate ",
        "Simulated Radar Reflectivity 1km",
        "Composite Radar Reflectivity",
        "Max Simulated Radar Reflectivity",
        "10 meter Wind",
        "2 meter Temperature and 10 meter Wind",
        "2 meter Dew Point and 10 meter wind",
        "10 meter wind gust",
        "Visibility",
        "Max 2-5km Updraft Helicity ",
        "Accumulated Maximum Updraft Helicity",
        "Max 10m Wind Speed",
        "Surface-Based Convective Available Potential Energy and Convective Inhibition",
        "Most Unstable Convective Available Potential Energy and Convective Inhibition",
        "250mb Wind",
        "300mb Wind",
        "500mb Vorticity, Wind, and Height",
        "500mb Temperature, Wind and Height",
        "700mb Relative Humidity, Wind, Height and Omega",
        "850mb Temperature, Wind, and Height",
        "925mb Temperature and Wind",
        "Cloud Ceiling "
    ]
    
    static let modelNam4kmParams = [
        "1000_500_thick",
        "1000_850_thick",
        "10m_wnd_precip",
        "850_700_thick",
        "850_temp_mslp_precip",
        "200_wnd_ht",
        "250_wnd_ht",
        "300_wnd_ht",
        "500_vort_ht",
        "500_temp_ht",
        "700_rh_ht",
        "850_temp_ht",
        "850_vort_ht",
        "925_temp_ht",
        "10m_maxwnd",
        "10m_wnd",
        "10m_wnd_sfc_gust",
        "2m_dewp_10m_wnd",
        "2m_temp_10m_wnd",
        "best_cape_cin",
        "echo_top",
        "ceiling",
        "helicity_1km",
        "helicity_3km",
        "max_updraft_hlcy",
        "sfc_cape_cin",
        "sim_radar_1km",
        "sim_radar_comp",
        "vis",
        "850vor_500ht_200wd",
        "dom_precip_type",
        "snodpth_chng",
        "precip_p01",
        "precip_p03",
        "precip_p06",
        "precip_p12",
        "precip_p24",
        "precip_p36",
        "precip_p48",
        "precip_p60",
        "precip_ptot",
        "precip_rate_type"
    ]
    
    static let modelNam4kmLabels = [
        "MSLP, 1000-500mb thickness, 6 hourly total precipitation",
        "MSLP, 1000-850mb thickness, 6 hourly total precipitation",
        "MSLP, 10m wind, 6 houly total precip, 2m temperature",
        "MSLP, 850-700mb thickness, 6 hourly total precipitation",
        "MSLP, 850mb temperature, 6 hourly total precipitation",
        "200mb Wind and Height",
        "250mb Wind and Height",
        "300mb Wind and Height",
        "500mb Vorticity, Wind, and Height",
        "500mb Temperature, Wind and Height",
        "700mb Relative Humidity, Height and Omega",
        "850mb Temperature, Wind and Height",
        "850mb Vorticity, Wind and Height",
        "925mb Temperature, Wind and Height",
        "Max 10m Wind Speed",
        "10 meter Wind",
        "10 meter wind gust",
        "2 meter Dew Point and 10 meter wind",
        "2 meter Temperature and 10 meter Wind",
        "Most Unstable Convective Available Potential Energy and Convective Inhibition",
        "Echo Top Height Image",
        "Cloud Ceiling",
        "0-1km Helicity and Storm Motion",
        "0-3km Helicity and Storm Motion",
        "Max 2-5km Updraft Helicity",
        "Surface-Based Convective Available Potential Energy and Convective Inhibition",
        "Simulated Radar Reflectivity 1km",
        "Composite Radar Reflectivity",
        "Visibility",
        "850mb Vorticity, 500mb Height, 200mb Wind",
        "Dominant Precipitation Type",
        "Snow Depth Change for previous 001 hours",
        "1 Hour Accumulated Precipitation",
        "3 Hour Accumulated Precipitation",
        "6 Hour Accumulated Precipitation",
        "12 Hour Accumulated Precipitation",
        "24 Hour Accumulated Precipitation",
        "36 Hour Accumulated Precipitation",
        "48 Hour Accumulated Precipitation",
        "60 Hour Accumulated Precipitation",
        "Precipitation Total",
        "Precip Rate(IN/HR), 1000-500MB Thickness"
    ]
    
    static let modelSrefParams = [
        "precip_p03",
        "precip_p06",
        "precip_p12",
        "precip_p24",
        "precip_ptot",
        "prob_precip_0.25in",
        "snow_total_mean",
        "snow_total_sprd",
        "1000_500_thick",
        "1000_850_thick",
        "10m_wind",
        "2m_temp",
        "850_700_thick",
        "cape",
        "cin",
        "lifted_index",
        "mslp",
        "prob_10m_wind",
        "prob_2m_temp",
        "prob_cape",
        "250_vort_ht",
        "250_wnd",
        "500_vort_ht",
        "700_rh",
        "700_temp",
        "850_rh",
        "850_temp",
        "850_wnd"
    ]
    
    static let modelSrefLabels = [
        "Mean 3-hour Precipitation",
        "Mean 6-hour Precipitation",
        "Mean 12-hour Precipitation",
        "Mean 24-hour Precipitation",
        "Total Accumulated Precipitation of Period",
        "Probability of 6-hrly Precipitation > 0.25 (in)",
        "Snow Mean for past 3 hours (in)",
        "Snow Spread for past 3 hours (in)",
        "Mean 1000-850mb Thickness (m)",
        "Mean 1000-500mb Thickness (m)",
        "10m Winds",
        "2m Temperature",
        "Mean 850-700mb Thickness (m)",
        "Mean Convective Available Potential Energy",
        "Mean Convective Inhibition",
        "Mean Lifted Index",
        "Mean Sea Level Pressure",
        "Probability of 10m Wind Speeds > 25 knots",
        "Probablility of 2m Temperature < 0",
        "Probability of Cape",
        "250mb Vorticity and Height",
        "250mb Wind",
        "500mb Vorticity and Height",
        "700mb Relative Humidity",
        "700mb Temperature",
        "850mb Relative Humidity",
        "850mb Temperature",
        "850mb Wind"
    ]
    
    static let modelNaefsParams = [
        "10m_wnd",
        "2m_temp",
        "mslp",
        "250_temp",
        "250_wnd",
        "500_temp",
        "500_vort_ht",
        "500_wnd",
        "700_temp",
        "700_vort_ht",
        "700_wnd",
        "850_temp",
        "850_vort_ht",
        "850_wnd",
        "925_wnd",
        "10th_percentile_10m_wnd",
        "50th_percentile_10m_wnd",
        "90th_percentile_10m_wnd",
        "extreme_index_10m_wnd",
        "10th_percentile_2m_temp",
        "50th_percentile_2m_temp",
        "90th_percentile_2m_temp",
        "extreme_index_2m_temp",
        "extreme_index_mslp"
    ]
    
    static let modelNaefsLabels = [
        "10m Winds",
        "2 meter Temperature",
        "Mean Sea Level Pressure",
        "250mb Temperature",
        "250mb Winds",
        "500mb Temperature",
        "500mb Vorticity and Height",
        "500mb Winds",
        "700mb Temperature",
        "700mb Vorticity and Height",
        "700mb Winds",
        "850mb Temperature",
        "850mb Vorticity and Height",
        "850mb Winds",
        "925mb Winds",
        "10th percentile 10m wind",
        "50th percentile 10m wind",
        "90th percentile 10m wind",
        "extreme index 10m wind",
        "10th percentile 2m temp",
        "50th percentile 2m temp",
        "90th percentile 2m temp",
        "extreme index 2m temp",
        "extreme index mslp"
    ]
    
    static let modelPolarParams = [
        "ice_drift"
    ]
    
    static let modelPolarLabels = [
        "Polar Ice Drift"
    ]
    
    static let modelHrwNmmParams = [
        "10m_wnd",
        "10m_wnd_sfc_gust",
        "2m_dewp_10m_wnd",
        "2m_temp_10m_wnd",
        "best_cape_cin",
        "ceiling",
        "echo_top",
        "helicity_1km",
        "helicity_3km",
        "max_updraft_hlcy",
        "sfc_cape_cin",
        "sim_radar_1km",
        "sim_radar_comp",
        "vis",
        "precip_p01",
        "precip_p03",
        "precip_p06",
        "precip_p12",
        "precip_p24",
        "precip_p36",
        "precip_p48",
        "precip_ptot",
        "dom_precip_type",
        "1000_500_thick",
        "10m_wnd_precip",
        "250_wnd_ht",
        "300_wnd_ht",
        "500_vort_ht",
        "700_rh_ht",
        "850_temp_ht"
    ]
    
    static let modelHrwNmmLabels = [
        "10 meter Wind",
        "10 meter wind gust",
        "2 meter Dew Point and 10 meter wind",
        "2 meter Temperature and 10 meter Wind",
        "Most Unstable Convective Available Potential Energy and Convective Inhibition",
        "Cloud Ceiling",
        "Echo Tops",
        "0-1km Helicity and Storm Motion",
        "0-3km Helicity and Storm Motion",
        "Max 2-5km Updraft Helicity",
        "Surface-Based Convective Available Potential Energy and Convective Inhibition",
        "Simulated Radar Reflectivity 1km",
        "Composite Radar Reflectivity",
        "Visibility",
        "Total Precipitation every 1 hours",
        "Total Precipitation every 3 hours",
        "Total Precipitation every 6 hours",
        "Total Precipitation every 12 hours",
        "Total Precipitation every 24 hours",
        "Total Precipitation every 36 hours",
        "Total Precipitation every 48 hours",
        "Precipitation Total",
        "Dominant Precipitation Type",
        "MSLP, 1000-500mb thickness, 3 hourly total precipitation",
        "MSLP, 10m wind, 6 houly total precip, 2m temperature",
        "250mb Wind and Height",
        "300mb Wind and Height",
        "500mb Vorticity, Wind, and Height",
        "700mb Relative Humidity, Wind, and Height",
        "850mb Temperature, Wind, and Height"
    ]
    
    static let modelGefsSpagParams = [
        "200_1176_ht",
        "200_1188_ht",
        "200_1200_ht",
        "200_1212_ht",
        "200_1224_ht",
        "200_1230_ht",
        "500_510_552_ht",
        "500_516_558_ht",
        "500_522_564_ht",
        "500_528_570_ht",
        "500_534_576_ht",
        "500_540_582_ht",
        "mslp_1000_1040_iso",
        "mslp_1004_1044_iso",
        "mslp_1008_1048_iso",
        "mslp_1012_1052_iso",
        "mslp_984_1024_iso",
        "mslp_996_1036_iso"
    ]
    
    static let modelGefsSpagLabels = [
        "200mb 1176 Height Contours",
        "200mb 1188 Height Contours",
        "200mb 1200 Height Contours",
        "200mb 1212 Height Contours",
        "200mb 1224 Height Contours",
        "200mb 1230 Height Contours",
        "500mb 510/552 Height Contours",
        "500mb 516/558 Height Contours",
        "500mb 522/564 Height Contours",
        "500mb 528/570 Height Contours",
        "500mb 534/576 Height Contours",
        "500mb 540/582 Height Contours",
        "MSLP 1000/1040 Isobar Contour",
        "MSLP 1004/1044 Isobar Contours",
        "MSLP 1008/1048 Isobar Contours",
        "MSLP 1012/1052 Isobar Contours",
        "MSLP 984/1024 Isobar Contours",
        "MSLP 996/1036 Isobar Contours"
    ]
    
    static let modelGefsMnsprdParams = [
        "dom_precip_type",
        "precip_p06",
        "precip_p24",
        "precip_ptot",
        "prob_ice_0.25in",
        "prob_precip_1in",
        "prob_precip_0.25in",
        "prob_precip_0.5in",
        "snodpth_chng_mean",
        "snodpth_chng_sprd",
        "10m_wnd",
        "2m_temp",
        "cape",
        "mslp",
        "prob_cape_2000",
        "prob_cape_250",
        "prob_cape_4000",
        "prob_cape_500",
        "250_temp",
        "250_wnd",
        "500_temp",
        "500_vort_ht",
        "500_wnd",
        "700_temp",
        "700_vort_ht",
        "700_wnd",
        "850_temp",
        "850_vort_ht",
        "850_wnd",
        "925_wnd"
    ]
    
    static let modelGefsMnsprdLabels = [
        "Dominant Precipitation Type",
        "Mean 6-hour Precipitation",
        "Mean 24-hour Precipitation",
        "Total Accumulated Precipitation of Period",
        "Probability of Ice > 0.25 (in)",
        "Probability of 6-hrly Precipitation > 1.00 (in)",
        "Probability of 6-hrly Precipitation > 0.25 (in)",
        "Probability of 6-hrly Precipitation > 0.50 (in)",
        "Mean of Snow Depth Change for previous 006 hours",
        "Spread of Snow Depth Change for previous 006 hours",
        "10m Winds",
        "2 meter Temperature",
        "Mean Convective Available Potential Energy",
        "Mean Sea Level Pressure",
        "Probability of CAPE > 2000",
        "Probability of CAPE > 250",
        "Probability of CAPE > 4000",
        "Probability of CAPE > 500",
        "250mb Temperature",
        "250mb Winds",
        "500mb Temperature",
        "500mb Vorticity and Height",
        "500mb Winds",
        "700mb Temperature",
        "700mb Vorticity and Height",
        "700mb Winds",
        "850mb Temperature",
        "850mb Vorticity and Height",
        "850mb Winds",
        "925mb Winds"
    ]
    
    static let paramsGefsWave = [
        "peak_dir_per",
        "sig_wv_ht",
        "wsea_dir_per",
        "wsea_wv_ht",
        "swell1_wv_ht",
        "swell1_dir_per",
        "swell2_wv_ht",
        "swell2_dir_per",
        "swell3_wv_ht",
        "swell3_dir_per"
    ]

    static let labelsGefsWave = [
        "Peak Wave Direction and Period (SEC)",
        "Significant Wave Heights (M) and Wind (KTS)",
        "Wind Sea Direction and Period (SEC)",
        "Wind Sea Wave Height (M) and Wind (KTS)",
        "Primary Swell Wave Height (M) and Wind (KTS)",
        "Primary Swell Direction and Period (SEC)",
        "Secondary Swell Wave Height (M) and Wind (KTS)",
        "Secondary Swell Direction and Period (SEC)",
        "Tertiary Swell Wave Height (M) and Wind (KTS)",
        "Tertiary Swell Direction and Period (SEC)"
    ]
    
    static let modelGfsWaveParams = [
        "peak_dir_per",
        "sig_wv_ht",
        "wsea_dir_per",
        "wsea_wv_ht",
        "swell1_wv_ht",
        "swell1_dir_per",
        "swell2_wv_ht",
        "swell2_dir_per",
        "swell3_wv_ht",
        "swell3_dir_per"
    ]
    
    static let modelGfsWaveLabels = [
        "Peak Wave Direction and Period (SEC)",
        "Significant Wave Heights (M) and Wind (KTS)",
        "Wind Sea Direction and Period (SEC)",
        "Wind Sea Wave Height (M) and Wind (KTS)",
        "Primary Swell Wave Height (M) and Wind (KTS)",
        "Primary Swell Direction and Period (SEC)",
        "Secondary Swell Wave Height (M) and Wind (KTS)",
        "Secondary Swell Direction and Period (SEC)",
        "Tertiary Swell Wave Height (M) and Wind (KTS)",
        "Tertiary Swell Direction and Period (SEC)"
    ]
    
    static let modelStofsParams = [
        "storm_surge",
        "total_water_level"
    ]
    
    static let modelStofsLabels = [
        "Storm surge relative to Mean Sea Level (feet)",
        "Total Water Level relative to Mean Sea Level (feet)"
    ]
    
    static let modelFirewxParams = [
        "precip_p01",
        "precip_p12",
        "precip_p24",
        "precip_p36",
        "precip_pwat",
        "dom_precip_type",
        "snodpth_chng",
        "2m_tmpc",
        "2m_dwpc",
        "2m_rh_10m_wnd",
        "10m_maxwnd",
        "sim_radar_1km",
        "sim_radar_comp",
        "haines",
        "vent_rate",
        "850_temp_ht",
        "max_downdraft",
        "max_updraft",
        "max_updraft_hlcy",
        "best_cape",
        "pbl_rich_height",
        "pbl_height",
        "transport_wind"
    ]
    
    static let modelFirewxLabels = [
        "Sea-level Pressure, 1-hr Accumulated Precip",
        "12-H Accumulated Precipitation",
        "24-H Accumulated Precipitation",
        "36-H Accumulated Precipitation",
        "Total Column Precipitable Water",
        "Categorical Precipitation Type",
        "Snow Depth Change from F00",
        "Shelter (2-m) Temperature",
        "Shelter (2-m) Dew Point Temperature",
        "1-hr Minimum Relative Humidity, 10-m Wind",
        "Maximum 1-hr 10-m Wind",
        "1000 m AGL Radar Reflectivity",
        "Composite Radar Reflectivity",
        "Haines Index",
        "Ventilation Rate",
        "850mb Temperature, Wind and Height",
        "Maximum 1-hr Downdraft Vertical Velocity",
        "Maximum 1-hr Updraft Vertical Velocity",
        "Maximum 2-5 km Updraft Helicity",
        "Best CAPE",
        "PBL Height (Based on Richardson Number)",
        "PBL Height",
        "Transport Wind and Terrain Height"
    ]
    
    static let paramsHrwArw2 = [
        "precip_p01",
        "precip_p03",
        "precip_p06",
        "precip_p12",
        "precip_p24",
        "precip_p36",
        "precip_p48",
        "precip_ptot",
        "sim_radar_1km",
        "sim_radar_comp",
        "1000_500_thick",
        "1000_850_thick",
        "850_700_thick",
        "10m_wnd",
        "10m_wnd_precip",
        "10m_wnd_sfc_gust",
        "2m_dewp_10m_wnd",
        "2m_temp_10m_wnd",
        "best_cape_cin",
        "sfc_cape_cin",
        "helicity_1km",
        "helicity_3km",
        "max_updraft_hlcy",
        "echo_top",
        "ceiling",
        "vis",
        "250_wnd_ht",
        "300_wnd_ht",
        "500_vort_ht",
        "700_rh_ht",
        "850_temp_ht"
    ]
    
    static let labelsHrwArw2 = [
        "Total Precipitation every 1 hour",
        "Total Precipitation every 3 hours",
        "Total Precipitation every 6 hours",
        "Total Precipitation every 12 hours",
        "Total Precipitation every 24 hours",
        "Total Precipitation every 36 hours",
        "Total Precipitation every 48 hours",
        "Total Accumulated Precipitation",
        "Simulated Radar Reflectivity 1km",
        "Composite Radar Reflectivity",
        "MSLP, 1000-500mb thickness, 3-hourly total precipitation",
        "MSLP, 1000-850mb thickness, 3-hourly total precipitation",
        "MSLP, 850-700mb thickness, 3-hourly total precipitation",
        "10 meter Wind",
        "MSLP, 10m wind, 3-hourly total precip, 2m temperature",
        "10 meter wind gust",
        "2 meter Dew Point and 10 meter wind",
        "2 meter Temperature and 10 meter Wind",
        "Most Unstable Convective Available Potential Energy and Convective Inhibition",
        "Surface-Based Convective Available Potential Energy and Convective Inhibition",
        "0-1km Helicity and Storm Motion",
        "0-3km Helicity and Storm Motion",
        "Max 2-5km Updraft Helicity ",
        "Echo Tops",
        "Cloud Ceiling ",
        "Visibility",
        "250mb Wind and Height",
        "300mb Wind and Height",
        "500mb Vorticity, Wind, and Height",
        "700mb Relative Humidity, Wind, and Height",
        "850mb Temperature, Wind, and Height"
    ]
    
    static let paramsHref = [
        "mean_precip_p01",
        "mean_precip_p03",
        "mean_precip_ptot",
        "blend_mean_precip_p01",
        "blend_mean_precip_p03",
        "blend_mean_precip_ptot",
        "pmm_refd_1km_emsl",
        "pmm_refd_max_emsl",
        "prob_refd_40dbz",
        "prob_refd_max_40dbz",
        "prob_cref_40dbz",
        "prob_cref_50dbz",
        "prob_rain",
        "prob_snow",
        "prob_sleet",
        "prob_freezing_rain",
        "prob_3h_rain_0.5in",
        "prob_3h_rain_1in",
        "mean_snow_1h",
        "mean_snow_3h",
        "mean_snow_total",
        "prob_1h_snow_1in",
        "prob_3h_snow_1in",
        "prob_3h_snow_3in",
        "mean_pwat",
        "prob_pwat_1.5in",
        "prob_pwat_2in",
        "mean_2m_temp",
        "prob_2m_temp_0C",
        "mean_2m_dewp",
        "prob_2m_dewp_55F",
        "prob_2m_dewp_65F",
        "prob_10m_wspd_20kt",
        "prob_10m_wspd_30kt",
        "mean_vis",
        "prob_vis_0.5mi",
        "prob_etop_30000ft",
        "prob_etop_35000ft",
        "prob_ceil_1000ft",
        "prob_ceil_2000ft",
        "prob_ceil_3000ft",
        "prob_low_IFR",
        "prob_IFR",
        "prob_marginal_VFR",
        "prob_VFR",
        "mean_ml_cape",
        "prob_cape_500",
        "prob_cape_1000",
        "prob_cape_2000",
        "prob_cape_3000",
        "mean_vwshr",
        "prob_vwshr_30kt",
        "prob_max_hlcy_25",
        "prob_max_hlcy_75",
        "prob_max_hlcy_100",
        "eas_prob_1h_rain_0.01in",
        "eas_prob_1h_rain_0.25in",
        "eas_prob_1h_rain_0.50in",
        "eas_prob_3h_rain_0.01in",
        "eas_prob_3h_rain_0.25in",
        "eas_prob_3h_rain_0.50in",
        "eas_prob_1h_snow_0.1in",
        "eas_prob_1h_snow_0.3in",
        "eas_prob_3h_snow_0.1in",
        "eas_prob_1h_snow_0.1in",
        "lpmm_mean_precip_p01",
        "lpmm_mean_precip_p03",
        "lpmm_mean_precip_ptot",
        "prob_lowIFR_IFR"
    ]
    
    static let labelsHref = [
        "1h mean precip",
        "3h mean precip",
        "Accumulated mean precip",
        "1h blend mean precip",
        "3h blend mean precip",
        "Accumulated blend mean precip",
        "PMM REFD 1 KM",
        "PMM COL MAX REFD",
        "Probability of 1km REFD greater than 40dBZ",
        "Probability of 1km MAX REFD greater than 40dBZ",
        "Probability of COMP MAX REFC greater than 40dBZ",
        "Probability of COMP MAX REFC greater than 50dBZ",
        "Probability of rain",
        "Probability of snow",
        "Probability of sleet",
        "Probability of freezing rain ",
        "Probability of rain greater than 0.5in in 3h",
        "Probability of rain greater than 1in in 3hr",
        "1-hr mean snow ",
        "3-hr mean snow ",
        "Mean snow total",
        "Probability of snow greater than 1in in 1h",
        "Probability of snow greater than 1in in 3h",
        "Probability of snow greater than 3in in 3hr",
        "Mean precipitable water ",
        "Probability of PWAT greater than 1.5in",
        "Probability of PWAT greater than 2.0in",
        "Mean 2m temp",
        "Probability of 2m temp less than 0C ",
        "Mean 2m dewpoint temp",
        "Probability of 2m dewpoint temp greater than 55F ",
        "Probability of 2m dewpoint temp greater than 65F ",
        "Probability of 10m wind speed greater than 20kt",
        "Probability of 10m wind speed greater than 30kt",
        "Mean visibility ",
        "Probability of visibility less than 0.5mile",
        "Probability of etop greater than 30000ft",
        "Probability of etop greater than 35000ft",
        "Probability of ceil hght less than 1000ft",
        "Probability of ceil hght less than 2000ft",
        "Probability of ceil hght less than 3000ft",
        "Probability of low instrument flt rule",
        "Probability of instrument flt rule",
        "Probability of marginal visual flt rule",
        "Probability of visual flt rule",
        "Mean mixed layer CAPE ",
        "Probability of mixed layer CAPE greater than 500J/kg",
        "Probability of mixed layer CAPE greater than 1000J/kg",
        "Probability of mixed layer CAPE greater than 2000J/kg",
        "Probability of mixed layer CAPE greater than 3000J/kg",
        "Mean vertical wind shear ",
        "Probability of vertical wind shear greater than 30kts",
        "Probability of max updraft helicity greater than 25m**2/s**2",
        "Probability of max updraft helicity greater than 75m**2/s**2",
        "Probability of max updraft helicity greater than 100m**2/s**2",
        "Ensemble Agreement Scale probability of 0.01” rain in 1 hour",
        "Ensemble Agreement Scale probability of 0.25” rain in 1 hour",
        "Ensemble Agreement Scale probability of 0.50” rain in 1 hour",
        "Ensemble Agreement Scale probability of 0.01” rain in 3 hours",
        "Ensemble Agreement Scale probability of 0.25” rain in 3 hours",
        "Ensemble Agreement Scale probability of 0.50” rain in 3 hours",
        "Ensemble Agreement Scale probability of 0.1” snow in 1 hour",
        "Ensemble Agreement Scale probability of 0.3” snow in 1 hour",
        "Ensemble Agreement Scale probability of 0.1” snow in 3 hours",
        "Ensemble Agreement Scale probability of 0.3” snow in 3 hours",
        "Localized probability matched mean mean precip 1 hour plot",
        "Localized probability matched mean mean precip 3 hour plot",
        "Localized probability matched mean mean precip total hour plot",
        "Probability Values for IFR/LIFR"
    ]
    
    static let paramsNbm = [
        "precip_p06",
        "precip_ptot",
        "2m_temp_10m_wnd",
        "2m_dewp_10m_wnd",
        "2m_relh_10m_wnd",
        "2m_apparent_temp",
        "10m_wnd_gust",
        "total_cloud_cover"
    ]
    
    static let labelsNbm = [
        "Total precipitation every 6 hours",
        "Accumulated precip",
        "2 meter Temperature and 10 meter Wind",
        "2 meter dew point temp and 10 meter wind",
        "2 meter Relative Humidity and 10 meter Wind",
        "2 meter Apparent Temperature and 10 meter Wind",
        "10 meter wind and gust",
        "Total Cloud Cover"
    ]
    
    static let modelHrwFv3Params = [
        "precip_p01",
        "precip_p03",
        "precip_p06",
        "precip_p12",
        "precip_p24",
        "precip_p36",
        "precip_p48",
        "precip_ptot",
        "sim_radar_1km",
        "sim_radar_comp",
        "1000_500_thick",
        "1000_850_thick",
        "850_700_thick",
        "10m_wnd",
        "10m_wnd_precip",
        "10m_wnd_sfc_gust",
        "2m_dewp_10m_wnd",
        "2m_temp_10m_wnd",
        "best_cape_cin",
        "sfc_cape_cin",
        "helicity_1km",
        "helicity_3km",
        "max_updraft_hlcy",
        "echo_top",
        "ceiling",
        "vis",
        "250_wnd_ht",
        "300_wnd_ht",
        "500_vort_ht",
        "700_rh_ht",
        "850_temp_ht"
    ]

    static let modelHrwFv3Labels = [
        "Total Precipitation every 1 hour",
        "Total Precipitation every 3 hours",
        "Total Precipitation every 6 hours",
        "Total Precipitation every 12 hours",
        "Total Precipitation every 24 hours",
        "Total Precipitation every 36 hours",
        "Total Precipitation every 48 hours",
        "Total Accumulated Precipitation",
        "Simulated Radar Reflectivity 1km",
        "Simulated Composite Radar Reflectivity",
        "MSLP, 1000-500mb thickness, 3-hourly total precipitation",
        "MSLP, 1000-850mb thickness, 3-hourly total precipitation",
        "MSLP, 850-700mb thickness, 3-hourly total precipitation",
        "10 meter Wind",
        "MSLP, 10m wind, 3-hourly total precip, 2m temperature",
        "10 meter wind gust",
        "2 meter Dew Point and 10 meter wind",
        "2 meter Temperature and 10 meter Wind",
        "Most Unstable Convective Available Potential Energy and Convective Inhibition",
        "Surface-Based Convective Available Potential Energy and Convective Inhibition",
        "0-1km Helicity and Storm Motion",
        "0-3km Helicity and Storm Motion",
        "Max 2-5km Updraft Helicity ",
        "Echo Tops",
        "Cloud Ceiling ",
        "Visibility",
        "250mb Wind and Height",
        "300mb Wind and Height",
        "500mb Vorticity, Wind, and Height",
        "700mb Relative Humidity, Wind, and Height",
        "850mb Temperature, Wind, and Height"
    ]
}
